from trac.util import format_date
from trac.ticket import Milestone
from trac.wiki.macros import WikiMacroBase
from genshi.builder import tag
from trac.util.datefmt import pretty_timedelta

class PlannedMilestones(WikiMacroBase):
    def get_info(self, milestone):
        if milestone.is_late:
            date_templ = '%s late (%s)'
        else:
            date_templ = 'Due in %s (%s) '
        ref = tag.a(milestone.name, href=self.env.href.milestone(milestone.name))
        date = date_templ % (pretty_timedelta(milestone.due), format_date(milestone.due))
        return date, ref
    
    def expand_macro(self, formatter, name, content):
        return tag.ul([tag.li(self.get_info(milestone)[1], tag.span(' - '),
                              self.get_info(milestone)[0]) 
                      for milestone in Milestone.select(self.env,
                                                        include_completed=False)
                                                        if milestone.due])
